#ifndef Maze_h
#define Maze_h
#define Maze_Width 16
#define Maze_Depth 16

#include <arduino.h>
//#include <BitBool.h>
class mazeClass {
  public:
    //    mazeClass(const byte x,const byte y);
    void clear();
    bool solvePart(); //do one pass of the maze solver and return true if maze solved
    void solve();     //do up to X*Y passes of maze solver to ensure entire maze is solved
    void list(int pos, byte direction); //Send asci representation of the maze to the serial port
    void block();     //add walls to all unknown cells in the maze
    byte direction_to_go(int pos); //return the best direction to go if the mouse is in position pos 1=north 2=east 3=south 4=west
    void addWalls(int pos, bool northWall, bool eastWall, bool southWall, bool westWall); //add walls to maze at position pos
    bool atTarget(int pos); //is mouse at target
    int cellsToMoveForward(int pos,byte direc); //return the number of cells in a line to the next unexplored cell or direction change
    void logCell(int pos); //output cell info to serial
    void logMaze(); //output maze info to serial as series of cells

    //byte topPos,rightPos; //top and right of maze to draw

    union cell {
      byte cell;
      struct {
        byte          : 3;  //1,2,4
        byte viseted  : 1;  //8
        byte west     : 1;  //16
        byte north    : 1;  //32
        byte east     : 1;  //64
        byte south    : 1;  //128
      } ;
    } mazemap[Maze_Width * Maze_Depth];

    byte mazework[Maze_Width * Maze_Depth];

    //int centre = (((Maze_Depth/2)*Maze_Width)+(Maze_Width/2)); //This will set the maze centre to near the centre of the maze
    //int centre = (((0x0)*Maze_Width)+(0x1));
    int centre = (((0x7)*Maze_Width)+(0x7)); //use this line to manually set the centre vertical then horizontal
    const int start = Maze_Width * Maze_Depth - Maze_Width;
    int target = centre;
  private:
};

#endif
